/*
 *  eXist Open Source Native XML Database
 *  Copyright (C) 2001-04 The eXist Project
 *  http://exist-db.org
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *  $Id: AssertFailure.java 965 2005-01-21 12:03:51Z wolfgang_m $
 */
package org.exist.util.sanity;

/**
 * Exception indicating a failed assertion. Used by
 * class {@link org.exist.util.sanity.SanityCheck} to print
 * a stack trace.
 * 
 * @author wolf
 */
public class AssertFailure extends RuntimeException {

    /**
     * 
     */
    public AssertFailure() {
        super();
    }

    /**
     * @param message
     */
    public AssertFailure(String message) {
        super(message);
    }

    /**
     * @param message
     * @param cause
     */
    public AssertFailure(String message, Throwable cause) {
        super(message, cause);
    }

}
