/*
 *  eXist Open Source Native XML Database
 *  Copyright (C) 2001-04 The eXist Project
 *  http://exist-db.org
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Id: ValidationService.java 3457 2006-05-07 14:46:21Z wolfgang_m $
 */

package org.exist.validation.service;

import org.exist.xmldb.XmldbURI;
import org.xmldb.api.base.Service;
import org.xmldb.api.base.XMLDBException;

/**
 *  Description of the methods that must be available in all 
 * ValidationServices
 *
 * @author dizzzz
 */
public interface ValidationService extends Service {
    
	/**
	 * @deprecated Use XmldbURI version instead
	 */
    boolean validateResource(String resourcePath) throws XMLDBException;
    boolean validateResource(XmldbURI resourcePath) throws XMLDBException;
}
