/*
 *  eXist Open Source Native XML Database
 *  Copyright (C) 2001-04 The eXist Project
 *  http://exist-db.org
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *  $Id: ConcurrentResourceTest2.java 4481 2006-10-04 14:54:50Z wolfgang_m $
 */
package org.exist.xmldb.test.concurrent;

import org.exist.storage.DBBroker;
import org.exist.xmldb.test.concurrent.action.MultiResourcesAction;
import org.exist.xmldb.test.concurrent.action.XQueryAction;
import org.xmldb.api.base.Collection;

/**
 * @author wolf
 */
public class ConcurrentResourceTest2 extends ConcurrentTestBase {

    private final static String URI = "xmldb:exist://" + DBBroker.ROOT_COLLECTION;
    
    private final static String QUERY0 =
        "declare default element namespace 'http://www.loc.gov/mods/v3';" +
        "collection(\"" + DBBroker.ROOT_COLLECTION + "\")//mods[titleInfo/title &= 'germany']";
    
    private final static String QUERY1 =
        "declare default element namespace 'http://www.loc.gov/mods/v3';" +
        "<result>{for $t in distinct-values(\"" + DBBroker.ROOT_COLLECTION + "\")//mods/subject/topic) order by $t return <topic>{$t}</topic>}</result>";
    
    public static void main(String[] args) {
        junit.textui.TestRunner.run(ConcurrentResourceTest2.class);
    }
    
    /**
     * 
     * 
     * @param name 
     */
    public ConcurrentResourceTest2(String name) {
        super(name, URI, "C1");
    }

    /* (non-Javadoc)
     * @see org.exist.xmldb.test.concurrent.ConcurrentTestBase#setUp()
     */
    protected void setUp() {
    	try {
	        super.setUp();	        
	        Collection c1 = DBUtils.addCollection(getTestCollection(), "C1-C2");
	        assertNotNull(c1);
	        addAction(new MultiResourcesAction("samples/mods", URI + "/C1/C1-C2"), 200, 0, 300);
	        addAction(new MultiResourcesAction("samples/mods", URI + "/C1/C1-C2"), 200, 0, 300);
	        addAction(new XQueryAction(URI + "/C1/C1-C2", "R1.xml", QUERY0), 200, 200, 500);
	        addAction(new XQueryAction(URI + "/C1/C1-C2", "R1.xml", QUERY1), 200, 300, 500);
			//addAction(new XQueryAction(URI + "/C1/C1-C2", "R1.xml", QUERY0), 200, 400, 500);
			//addAction(new XQueryAction(URI + "/C1/C1-C2", "R1.xml", QUERY1), 200, 500, 500);
    	} catch (Exception e) {            
            fail(e.getMessage()); 
        }		        
    }
}
